(define-module (ui tc-lock ajax)
							 :use-module (alterator ajax)
							 :use-module (alterator woo)
							 :export (init))

; Station is in unlocked state
(define (not-locked)
	(form-update-visibility "table_locked" #f)
	(form-update-visibility "table_not_locked" #t))

; Station is in locked state
(define (locked)
	(form-update-visibility "table_locked" #t)
	(form-update-visibility "table_not_locked" #f))

; Lock station
(define (click-lock)
	(and
	(catch/message
		(lambda()
			(woo-write "/tc_lock" 'lock "yes")
			))
	(refresh-status)))

; Unlock station
(define (click-unlock)
	(and
	(catch/message
		(lambda()
			(woo-write "/tc_lock" 'lock "no")
			))
	(refresh-status)))

; Re-read current workstation status
(define (refresh-status)
	(let* ((status (woo-read-first "/tc_lock" 'language (form-value "language")))
           (islocked (woo-get-option status 'locked)))
      (cond ((string=? islocked "yes") (locked))
            ((string=? islocked "no") (not-locked)))))

; Module initialization
(define (init)
	; Interconnect button with action 
	(form-bind "btn_lock" "click" click-lock)
	(form-bind "btn_unlock" "click" click-unlock)
	; Read current status
	(refresh-status))
